--require "basementpath"
require "Basement"

function real_install(srcdir, rootdir, update)
	local dstdir = string.format('%s\\%s', rootdir, component['name']);

	for svcname, svcexecutable in pairs(component['svcname']) do
		TSA_StopService(svcname, string.format("%s\\%s", dstdir, svcexecutable));
	end
    donelastop = true;

	TSA_UpdateComponentFiles(component['category'], srcdir, dstdir, update);

	TSA_InstallComponetConfigToEP (component['name'], srcdir, string.format("%s\\ep", rootdir));

	TSA_InstallComponetPolicytoEp ("d49170c0-b076-4795-b079-0f97560485af_1.policy", dstdir, string.format("%s\\ep", rootdir))

	--  NetConfig.ini  prvcloudcfg.ini  ep 
	--[[
	ATM_CopyFile(string.format("%s\\NetConfig.ini", srcdir), string.format("%s\\ep\\NetConfig.ini", rootdir));
	ATM_CopyFile(string.format("%s\\prvcloudcfg.ini", srcdir),  string.format("%s\\ep\\prvcloudcfg.ini", rootdir));
	--]]
	do
		local qlink 	= winfunc.WinQuickLink()
		local toollink 	= string.format("%s\\%s\\ָ.lnk", tostring(qlink.GetStartMenuPos()), tostring(component['startmenu']));
		local toolpath 	= string.format("%s\\rsbootbk.exe", dstdir);
		TrackOp(qlink.CreateLink(toollink, toolpath, nil, "ָ", nil), VerifyResult,
				string.format("create link[%s: %s]", toollink, toolpath)
			   );
	end
	do
		local qlink 	= winfunc.WinQuickLink()
		local toollink 	= string.format("%s\\%s\\ɱ.lnk", tostring(qlink.GetStartMenuPos()), tostring(component['startmenu']));
		local toolpath 	= string.format("%s\\ep\\eptray.exe", rootdir);
		TrackOp(qlink.CreateLink(toollink, toolpath, nil, "ɱ", nil), VerifyResult,
				string.format("create link[%s: %s]", toollink, toolpath)
			   );
	end
	if update~=true then
		do
			local qlink 	= winfunc.WinQuickLink()
			local toollink 	= string.format("%s\\ɱ.lnk", tostring(qlink.GetDesktopPos()));
			local toolpath 	= string.format("%s\\ep\\eptray.exe", rootdir);
			TrackOp(qlink.CreateLink(toollink, toolpath, nil, "ɱ", nil), VerifyResult,
					string.format("create link[%s: %s]", toollink, toolpath)
				   );
		end
	end

	--[[
	 xav\skin Ŀ¼ *.wip ļѹļ
	--]]
	local filefind = winfunc.WinFileFind()
	local skindir = string.format("%s\\skin\\*.wip", dstdir) --Ƥļ
	local bFindFile = filefind.FindFile(skindir, 0)
	while bFindFile == true do
		bFindFile = filefind.FindNextFile();
		local zipobj = winfunc.WinZip()
		local srczipfile = filefind.GetFilePath()
		---[[ ҪעԶַLUAַ֮ת tostring
		local deszipdir = string.format("%s\\skin\\%s", dstdir, tostring(filefind.GetFileTitle())) -- ѹĿ¼
		--winfunc.msgbox(srczipfile, deszipdir)
		ATM_DelPath(deszipdir)
		ATM_UnzipFile(tostring(srczipfile), tostring(deszipdir), "")
		--]]
	end
end

function install (srcdir, rootdir)
	return real_install(srcdir, rootdir, false);
end


function update (srcdir, rootdir)
	return real_install(srcdir, rootdir, true);
end


function uninstall (srcdir, rootdir)
	--[[ 
	1. all client component depend ep, we must stop "esmep" and "eptray" first.
	--]]
	TSA_StopService('esmep', string.format("%s\\ep\\esm.exe", rootdir));
	TSA_StopService('epsrv', string.format("%s\\ep\\epsrv.exe", rootdir));
	ATM_ExitProcessDuration(string.format("%s\\ep\\eptray.exe", rootdir), 60);
    donelastop = true;
	
	--[[
	2. do xav uninstall.
	--]]
	
    TSA_RemoveComponentFiles(string.format('%s\\%s', rootdir, component['name']));
    donelastop = true;

	TSA_UninstallComponetConfigUnderEP (component['name'], string.format("%s\\ep", rootdir))
	donelastop = true;

	TSA_UninstallComponetPolicyToEp ( "d49170c0-b076-4795-b079-0f97560485af_1.policy", string.format("%s\\ep", rootdir) )

	do
		local qlink = winfunc.WinQuickLink();
		local toollink 	= string.format("%s\\%s\\ָ.lnk", tostring(qlink.GetStartMenuPos()), tostring(component['startmenu']));
		ATM_DelPath(toollink);
	end
	do
		local qlink = winfunc.WinQuickLink();
		local toollink 	= string.format("%s\\%s\\ɱ.lnk", tostring(qlink.GetStartMenuPos()), tostring(component['startmenu']));
		ATM_DelPath(toollink);
	end
	do
		local qlink = winfunc.WinQuickLink();
		local toollink 	= string.format("%s\\ɱ.lnk", tostring(qlink.GetDesktopPos()));
		ATM_DelPath(toollink);
	end
	
	--[[
	3. restart "esmep", esmep will start other auto.
	--]]
	TSA_StartService("esmep")
end


function collectparam (srcdir, rootdir)
	-- do nothing
end


function run ()
	for svcname, svcexecutable in pairs(component['svcname']) do
		TSA_StartService(svcname);
	end
end

function runbefore(srcdir, rootdir)
	local cmd 		= winfunc.GetCmdLine();
	cmd = string.lower(cmd)
	if string.find(cmd, "tray") or string.find(cmd, "silence") then
		return
	end
	-- copy xavscan.exe to ep and run it.
	local srcfile = string.format("%s\\%s\\xavscan.exe", rootdir, component['name']);
	local desfile = string.format("%s\\ep\\xavscan.exe", rootdir)
	ATM_CopyFile(srcfile, desfile)
	local cmdline = string.format("%s\\ep\\xavscan.exe /s /k /t 20", rootdir)
	--[[ debug quit
	local cmdline = string.format("%s\\ep\\xavscan.exe /s /f c:\ /t 20", rootdir)
	--]]
	local title = string.format("%s ǰ...", component['name'])
	winfunc.DoQuickScan(g_ParentHwnd, title, cmdline, 20)
end

component = {name='xav', category='xav.xml', role = 'monitor', startmenu='ҵն˰ȫϵͳ',  svcname = {esmep = 'esm.exe', epsrv = 'epsrv.exe'}};



